<?php

	define("MODULE_NAME","ImageGallery_1.0.0");
	define("TABLE_CATEGORY",TABLE_PREFIX."mod_gallery_category");
	define("TABLE_ITEMS",TABLE_PREFIX."mod_gallery_items");
	
	define("BROWSE",0);
	define("CREATE_CATEGORY",1);
	define("ADD_CATEGORY",2);
	define("EDIT_CATEGORY",3);
	define("UPDATE_CATEGORY",4);
	define("DELETE_CATEGORY",5);
	define("CREATE_ITEM",6);
	define("ADD_ITEM",7);
	define("EDIT_ITEM",8);
	define("UPDATE_ITEM",9);
	define("DELETE_ITEM",10);

	class ModuleAdmin {		

		function GetItemCount ($category_id)
			{
			global $IW;
			$result = $IW->DB_Query("select id from ".TABLE_ITEMS." where category_id='".$category_id."' ");
			$count=$IW->DB_CountResult($result);
			$IW->DB_FreeResult($result);
			return $count;
			}

		function GetCategoryCount ($category_id)
			{
			global $IW;
			$result = $IW->DB_Query("select id from ".TABLE_CATEGORY." where parent_id='".$category_id."' ");
			$count=$IW->DB_CountResult($result);
			$IW->DB_FreeResult($result);
			return $count;
			}

		function GetParentId ($id)
			{
			global $IW;
			$result = $IW->DB_Query("select parent_id from ".TABLE_CATEGORY." where id='".$id."' ");
			$parent=$IW->DB_Result($result,0,"parent_id");
			$IW->DB_FreeResult($result);
			return $parent;
			}

		function GetCategoryTitle ($id)
			{
			global $IW;
			$result = $IW->DB_Query("select title from ".TABLE_CATEGORY." where id='".$id."' ");
			$title=$IW->DB_Result($result,0,"title");
			$IW->DB_FreeResult($result);
			return $title;
			}

		function HasParentCategory ($id)
			{
			global $IW;
			$result = $IW->DB_Query("select parent_id from ".TABLE_CATEGORY." where id='".$id."' ");
			$parent=$IW->DB_Result($result,0,"parent_id");
			$IW->DB_FreeResult($result);
			if(empty($parent)){return false;}
			else{return true;}
			}

		function HasChildCategory ($id)
			{
			global $IW;
			$result = $IW->DB_Query("select id from ".TABLE_CATEGORY." where parent_id='".$id."' ");
			$child=$IW->DB_Result($result,0,"id");
			$IW->DB_FreeResult($result);
			if(empty($child)){return false;}
			else{return true;}
			}

		function BuildCategoryNavbar ($category_id)
			{
			global $IW;
			$navbar=Array();
			$ArrayLink=$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME."&category=".$category_id;
			array_push($navbar,"<a href=\"".$ArrayLink."\">".$this->GetCategoryTitle ($category_id) ."</a> / ");
			if($this->HasParentCategory ($category_id))
				{
				$id=$this->GetParentId($category_id);	
				$this->BuildCategoryNavbar ($id);
				}
			rsort($navbar); 
			for($i=0;$i<count($navbar);$i++){echo $navbar[$i];}
			}

		function Browse ($category_id="")
			{
			global $IW;
			if(empty($category_id))
				{
				$result = $IW->DB_Query("select * from ".TABLE_CATEGORY." where parent_id is NULL or parent_id='0' order by title");		
				}
			else
				{
				$IW->UI_OpenTable();
				echo "<tr><td><b>";
				$BrowseLink=$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME;
				echo "<a href=\"".$BrowseLink."\">".MODA_0."</a> / ";
				$this->BuildCategoryNavbar ($category_id);
				echo "</b></td></tr>";
				$IW->UI_CloseTable();
				$result = $IW->DB_Query("select * from ".TABLE_CATEGORY." where parent_id='".$category_id."' order by title");
				}
			$IW->UI_OpenTable();
			echo "<tr>";
			echo "<td class=\"TableHeader\">".$IW->UI_Label(MODA_1)."</td>";
			if(empty($category_id))
				{
				$CreateCategoryAction=$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME;
				$CreateCategoryAction.="&category=".$category_id."&modcmd=".CREATE_CATEGORY;
				$CreateCategoryButton=MODA_2;
				$IW->UI_OpenForm("",$CreateCategoryAction,"");
				echo "<td colspan=2 class=\"TableHeader\" align=\"center\">".$IW->UI_Submit($CreateCategoryButton)."</td>";
				$IW->UI_CloseForm();
				}
			else
				{
				$CreateCategoryAction=$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME;
				$CreateCategoryAction.="&category=".$category_id."&modcmd=".CREATE_CATEGORY;
				$CreateCategoryButton=MODA_3." ".$this->GetCategoryTitle($category_id);
				$IW->UI_OpenForm("",$CreateCategoryAction,"");
				echo "<td colspan=2 class=\"TableHeader\" align=\"center\">".$IW->UI_Submit($CreateCategoryButton)."</td>";
				$IW->UI_CloseForm();
				}
			echo "</tr>";
			$row=0;
			for($i=0;$i<$IW->DB_CountResult($result);$i++)
				{
				if($row==0){$class="TableRow1";}
				else{$class="TableRow2";}
				echo "<tr>";
				$CategoryLinkTitle=$IW->DB_Result($result,$i,"title");
				$CategoryLink=$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME;
				$CategoryLink.="&category=".$IW->DB_Result($result,$i,"id");
				$TotalCategories=$this->GetCategoryCount($IW->DB_Result($result,$i,"id"));
				$TotalItems=$this->GetItemCount($IW->DB_Result($result,$i,"id"));
				$TotalCount=($TotalCategories+$TotalItems);		
				echo "<td class=\"".$class."\">".$IW->UI_Label("<a href=\"".$CategoryLink."\">".$CategoryLinkTitle."</a>")." (".$TotalCount.")</td>";
				$EditCategoryAction=$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME;
				$EditCategoryAction.="&category=".$category_id."&modcmd=".EDIT_CATEGORY."&id=".$IW->DB_Result($result,$i,"id");
				$EditCategoryButton=MODA_4;
				$IW->UI_OpenForm("",$EditCategoryAction,"");
				echo "<td class=\"".$class."\" align=\"center\" width=80>". $IW->UI_Submit($EditCategoryButton)."</td>";
				$IW->UI_CloseForm();
				$DeleteCategoryAction=$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME;
				$DeleteCategoryAction.="&category=".$category_id."&modcmd=".DELETE_CATEGORY."&id=".$IW->DB_Result($result,$i,"id");
				$DeleteCategoryButton=MODA_5;
				$IW->UI_OpenForm("",$DeleteCategoryAction,"");
				echo "<td class=\"".$class."\" align=\"center\" width=80>". $IW->UI_Submit($DeleteCategoryButton)."</td>";
				$IW->UI_CloseForm();
				echo "</tr>";
				if($row==0){$row=1;}
				else{$row=0;}
				}
			$IW->UI_CloseTable();
 			$this->DisplayItems ($category_id);
			$IW->DB_FreeResult($result);
			}

		function DisplayItems ($category_id)
			{
			global $IW;		
			$sql="select * from ".TABLE_ITEMS." where category_id='".$category_id."' order by title";
			$result=$IW->DB_Query($sql);
			$matches=$IW->DB_CountResult($result);
			$IW->DB_FreeResult($result);
			if(!isset($_REQUEST['prevoffset'])){$_REQUEST['prevoffset']=0;}
			if(!isset($_REQUEST['offset'])){$_REQUEST['offset']=0;}
			$sql .=" limit ".$_REQUEST['offset'].",10";		
			$result = $IW->DB_Query($sql);
			$IW->UI_OpenTable();
			echo "<tr>";
			echo "<td class=\"TableHeader\" colspan=6>".$IW->UI_Label(MODA_6)."</td>";
			if(!empty($category_id))
				{
				$AddItemAction=$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME;
				$AddItemAction.="&category=".$category_id."&modcmd=".CREATE_ITEM;
				$AddItemButton=MODA_7." ".$this->GetCategoryTitle($category_id);
				$IW->UI_OpenForm("",$AddItemAction,"");
				echo "<td colspan=2 class=\"TableHeader\" align=\"center\">".$IW->UI_Submit($AddItemButton)."</td>";
				$IW->UI_CloseForm();	
				}
			else
				{
				$AddItemAction=$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME;
				$AddItemAction.="&category=".$category_id."&modcmd=".CREATE_ITEM;
				$AddItemButton=MODA_8;
				$IW->UI_OpenForm("",$AddItemAction,"");
				echo "<td colspan=2 class=\"TableHeader\" align=\"center\">".$IW->UI_Submit($AddItemButton)."</td>";
				$IW->UI_CloseForm();	
				}
			echo "</tr>";
			$row=0;
			for($i=0;$i<$IW->DB_CountResult($result);$i++)
				{
				if($row==0){$class="TableRow1";}
				else{$class="TableRow2";}
				echo "<tr>";			
				$filename=$IW->DB_Result($result,$i,"filename");
				if(!file_exists(DIR_FILES.$filename)){echo "<td class=\"".$class."\" colspan=6>Error Loading Image : ".DIR_FILES.$filename."</td>";}
				else
					{
					$size=getimagesize(DIR_FILES.$filename);
					$OriginalWidth=$size[0];
					$OriginalHeight=$size[1];
					$ThumbWidth=($size[0]/4);
					$ThumbHeight=($size[1]/4);
					switch($size[2])
						{
						case 1: $MIMEType="GIF"; break;case 2: $MIMEType="JPG"; break;
						case 3: $MIMEType="PNG"; break;case 4: $MIMEType="SWF"; break;
						case 5: $MIMEType="PSD"; break;case 6: $MIMEType="BMP"; break;
						case 7: $MIMEType="TIFF(PC)"; break;case 8: $MIMEType="TIFF(MAC)"; break;
						case 9: $MIMEType="JPC"; break;case 10: $MIMEType="JP2"; break;
						case 11: $MIMEType="JPX"; break;case 12: $MIMEType="JB2"; break;
						case 13: $MIMEType="SWC"; break;case 14: $MIMEType="IFF"; break;
						case 15: $MIMEType="WBMP"; break;case 16: $MIMEType="XBM"; break;
						}
					$Filesize=filesize(DIR_FILES.$filename);
					echo "<td class=\"".$class."\"><img src=\"".DIR_FILES.$filename."\" width=\"".$ThumbWidth."\" height=\"".$ThumbHeight."\" border=1></td>";
					echo "<td class=\"".$class."\">".$IW->UI_Label($IW->DB_Result($result,$i,"title"))."</td>";	
					echo "<td class=\"".$class."\">".$filename."</td>";
					echo "<td class=\"".$class."\">".$OriginalWidth." x ".$OriginalHeight."</td>";
					echo "<td class=\"".$class."\">".$MIMEType."</td>";
					echo "<td class=\"".$class."\">".$Filesize." bytes</td>";
					}
				$EditItemAction=$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME;
				$EditItemAction.="&category=".$category_id."&modcmd=".EDIT_ITEM."&id=".$IW->DB_Result($result,$i,"id");
				$EditItemButton=MODA_9;
				$IW->UI_OpenForm("",$EditItemAction,"");
				echo "<td class=\"".$class."\" align=\"center\" width=80>".$IW->UI_Submit($EditItemButton)."</td>";
				$IW->UI_CloseForm();				
				$DeleteItemAction=$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME;
				$DeleteItemAction.="&category=".$category_id."&modcmd=".DELETE_ITEM."&id=".$IW->DB_Result($result,$i,"id");
				$DeleteItemButton=MODA_10;
				$IW->UI_OpenForm("",$DeleteItemAction,"");
				echo "<td class=\"".$class."\" align=\"center\" width=80>".$IW->UI_Submit($DeleteItemButton)."</td>";
				$IW->UI_CloseForm();	
				if($row==0){$row=1;}
				else{$row=0;}
				}
			$IW->UI_CloseTable();
			$IW->DB_FreeResult($result);
			$IW->UI_OpenTable();
			echo "<tr>";
			if ($_REQUEST['offset']!=0) 
				{
				$PrevPageAction=$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME;
				$PrevPageAction.="&category=".$category_id."&offset=".($_REQUEST['offset']-3);
				$PrevPageButton=MODA_11;
				$IW->UI_OpenForm("",$PrevPageAction,"");
				echo "<td>".$IW->UI_Submit($PrevPageButton)."</td>";
				$IW->UI_CloseForm();	
				}
			$pages=intval($matches/10);
			if ($matches%10) {$pages++;}
			echo "<td>";
			for ($i=1;$i<=$pages;$i++) 
				{
				$newoffset=10*($i-1);
				$PageNumberLink=$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME;
				$PageNumberLink.="&category=".$category_id."&offset=".$newoffset;
				$PageNumberLinkTitle=$i;
				echo "<a href=\"".$PageNumberLink."\">".$PageNumberLinkTitle."</a> \n";
				}
			echo "</td>";
			if (!(($_REQUEST['offset']/10)==$pages) && $pages!=1) 
				{
				$newoffset=$_REQUEST['offset']+10;
				$NextPageAction=$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME;
				$NextPageAction.="&category=".$category_id."&offset=".$newoffset;
				$NextPageButton=MODA_12;
				$IW->UI_OpenForm("",$NextPageAction,"");
				echo "<td>".$IW->UI_Submit($NextPageButton)."</td>";
				$IW->UI_CloseForm();	
				}
			echo "</tr>";
			$IW->UI_CloseTable();
			}

	function CategoryForm ($category_id,$mode,$id="")
		{
		global $IW;
		if($mode==1)
			{
			$FormTitle=MODA_13;
			$FormAction=$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME;
			$FormAction.="&category=".$category_id."&modcmd=".UPDATE_CATEGORY."&id=".$id;
			$FormButton=MODA_14;
			$result=$IW->DB_Query("select * from ".TABLE_CATEGORY." where id='".$id."' limit 1");
			$title=$IW->DB_Result($result,0,"title");
			$description=$IW->DB_Result($result,0,"description");
			$IW->DB_FreeResult($result);
			}
		else
			{
			$FormTitle=MODA_15;
			$FormAction=$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME;
			$FormAction.="&category=".$category_id."&modcmd=".ADD_CATEGORY;
			$FormButton=MODA_16;
			$title='';
			$description='';
			}
		echo $IW->UI_Label($FormTitle);
		$IW->UI_OpenForm("",$FormAction,"");
		echo $IW->UI_Hidden("category",$category_id);
		$IW->UI_OpenTable();
		echo "<tr><td>".$IW->UI_Label(MODA_17)."</td><td>".$IW->UI_TextBox("title",$title,30)."</td></tr>";
		echo "<tr><td>".$IW->UI_Label(MODA_18)."</td><td>".$IW->UI_TextArea("description",$description,3,40)."</td></tr>";
		$IW->UI_CloseTable();
		echo $IW->UI_Submit($FormButton);
		$IW->UI_CloseForm();
		}

	function ItemForm ($category_id,$mode,$id="")
		{
		global $IW;
		if($mode==1)
			{
			$FormTitle=MODA_19;
			$FormAction=$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME;
			$FormAction.="&category=".$category_id."&modcmd=".UPDATE_ITEM."&id=".$id;
			$FormButton=MODA_20;
			$result=$IW->DB_Query("select * from ".TABLE_ITEMS." where id='".$id."' limit 1");
			$title=$IW->DB_Result($result,0,"title");
			$description=$IW->DB_Result($result,0,"description");
			$filename=$IW->DB_Result($result,0,"filename");
			$IW->DB_FreeResult($result);
			}
		else
			{
			$FormTitle=MODA_21;
			$FormAction=$_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME;
			$FormAction.="&category=".$category_id."&modcmd=".ADD_ITEM;
			$FormButton=MODA_22;
			$title="";
			$description="";
			$filename="";
			}
		echo $IW->UI_Label($FormTitle);
		$IW->UI_OpenForm("",$FormAction,"");
		echo $IW->UI_Hidden("category",$category_id);
		$IW->UI_OpenTable();
		echo "<tr><td>".$IW->UI_Label(MODA_23)."</td><td>";
		$IW->UI_OpenListBox("filename",1);
		if($mode==1){echo $IW->UI_ListOption($filename,$filename,1);}
		$IW->Files_ListBox ();
		$IW->UI_CloseListBox ();
		echo "</td></tr>";		
		echo "<tr><td>".$IW->UI_Label(MODA_24)."</td><td>".$IW->UI_TextBox("title",$title,30)."</td></tr>";
		echo "<tr><td>".$IW->UI_Label(MODA_25)."</td><td>".$IW->UI_TextArea("description",$description,3,40)."</td></tr>";
		$IW->UI_CloseTable();
		echo $IW->UI_Submit($FormButton);
		$IW->UI_CloseForm();
		}

	function AddCategory ($category_id)
		{
		global $IW;
		$title=$IW->DB_ParseInput($_REQUEST['title']);
		$description=$IW->DB_ParseInput($_REQUEST['description']);
		$sql="insert into ".TABLE_CATEGORY." (parent_id,title,description) ";
		$sql.="values ('".$category_id."','".$title."','".$description."')";
		$IW->DB_Query($sql);
		$IW->UI_Message(MODA_27);
		$IW->UI_Navigate($_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME."&category=".$category_id);
		}

	function AddItem ($category_id)
		{
		global $IW;
		$title=$IW->DB_ParseInput($_REQUEST['title']);
		$filename=$IW->DB_ParseInput($_REQUEST['filename']);
		$description=$IW->DB_ParseInput($_REQUEST['description']);
		$sql="insert into ".TABLE_ITEMS." (category_id,title,filename,description) ";
		$sql.="values ('".$category_id."','".$title."','".$filename."','".$description."')";
		echo $sql;
		$IW->DB_Query($sql);
		$IW->UI_Message(MODA_28);
		$IW->UI_Navigate($_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME."&category=".$category_id);
		}

	function UpdateCategory ($category_id,$id)
		{
		global $IW;
		$sql ="update ".TABLE_CATEGORY." set ";
		$sql.="parent_id='".$category_id."',";
		$sql.="title='".$IW->DB_ParseInput($_REQUEST['title'])."',";
		$sql.="description='".$IW->DB_ParseInput($_REQUEST['description'])."' ";
		$sql.="where id='".$id."' limit 1";
		$IW->DB_Query($sql);
		$IW->UI_Message(MODA_29);
		$IW->UI_Navigate($_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME."&category=".$category_id);
		}

	function UpdateItem ($category_id,$id)
		{
		global $IW;
		$sql ="update ".TABLE_ITEMS." set ";
		$sql.="category_id='".$category_id."',";
		$sql.="title='".$IW->DB_ParseInput($_REQUEST['title'])."',";
		$sql.="filename='".$IW->DB_ParseInput($_REQUEST['filename'])."',";
		$sql.="description='".$IW->DB_ParseInput($_REQUEST['description'])."' ";
		$sql.="where id='".$id."' limit 1";
		$IW->DB_Query($sql);
		$IW->UI_Message(MODA_30);
		$IW->UI_Navigate($_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME."&category=".$category_id);
		}

	function DeleteCategory ($category_id,$id)
		{
		global $IW;
		if($this->HasChildCategory ($id)||$this->GetItemCount($id)>0)
			{$IW->UI_Message(MODA_31);}
		else
			{
			$IW->DB_Query("delete from ".TABLE_CATEGORY." where id='".$id."' limit 1");
			$IW->UI_Message(MODA_32);
			}
		$IW->UI_Navigate($_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME."&category=".$category_id);
		}

	function DeleteItem ($category_id,$id)
		{
		global $IW;
		$result=$IW->DB_Query("delete from ".TABLE_ITEMS." where id='".$id."' limit 1");
		$IW->UI_Message(MODA_33);
		$IW->UI_Navigate($_SERVER['PHP_SELF']."?cmd=".MODS_USE."&file=".MODULE_NAME."&category=".$category_id);
		}

	// End Class
	}
	$Mod = new ModuleAdmin ();
	$IW->UI_OpenWidget(MODA_34);

	if(!isset($_REQUEST['category'])){$_REQUEST['category']="";}	
	if(!isset($_REQUEST['modcmd'])){$_REQUEST['modcmd']=BROWSE;}
	switch($_REQUEST['modcmd'])
		{
		case BROWSE:
			$Mod->Browse ($_REQUEST['category']);
		break;
		case CREATE_CATEGORY:
			$Mod->CategoryForm($_REQUEST['category'],0);
		break;
		case ADD_CATEGORY:
			$Mod->AddCategory($_REQUEST['category']);
		break;
		case EDIT_CATEGORY:
			$Mod->CategoryForm($_REQUEST['category'],1,$_REQUEST['id']);
		break;
		case UPDATE_CATEGORY:
			$Mod->Updatecategory($_REQUEST['category'],$_REQUEST['id']);
		break;
		case DELETE_CATEGORY:
			$Mod->DeleteCategory($_REQUEST['category'],$_REQUEST['id']);
		break;
		case CREATE_ITEM:
			$Mod->ItemForm($_REQUEST['category'],0);
		break;
		case ADD_ITEM:
			$Mod->AddItem($_REQUEST['category']);
		break;
		case EDIT_ITEM:
			$Mod->ItemForm($_REQUEST['category'],1,$_REQUEST['id']);
		break;
		case UPDATE_ITEM:
			$Mod->UpdateItem($_REQUEST['category'],$_REQUEST['id']);
		break;
		case DELETE_ITEM:
			$Mod->DeleteItem($_REQUEST['category'],$_REQUEST['id']);
		break;
		}

	$IW->UI_CloseWidget();
?>